.386
.MODEL 	FLAT,STDCALL
option 	casemap:none
include	DProgress.inc

.code

start:
	mov hInstance,FUNC (GetModuleHandle, NULL)
	mov	hDll,FUNC (LoadLibrary,chr$('DrawProgress.dll'))
	.if eax	
		invoke InitCommonControls
		invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DlgProc,NULL
		invoke FreeLibrary,hDll
	.endif			
	invoke ExitProcess,0
       

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	idThread,hDP1,hDP2:DWORD 
	   
	Switch uMsg
	Case WM_INITDIALOG
		m2m hWnd, hWin
		mov hFont, FUNC (CreateFontA,16,0,0,0,FW_BLACK,0,0,0,0,0,0,PROOF_QUALITY,0,chr$("Times New Roman"))
		
		mov pBmp1, FUNC (BitmapFromResource, hInstance,9)
		mov pBmp2, FUNC (BitmapFromResource, hInstance,8)
		mov pBmp3, FUNC (LoadBitmap, hInstance,201)
		mov pBmp4, FUNC (LoadBitmap, hInstance,202)		
		invoke SendDlgItemMessage,hWnd,1001,BM_SETIMAGE,IMAGE_BITMAP,pBmp3	
		mov PBrushD,FUNC (CreatePatternBrush,pBmp1)
		mov PBrushD2,FUNC (CreatePatternBrush,pBmp2)
		mov PBrushD3,FUNC (CreatePatternBrush,pBmp4)
		
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC2),WM_SETFONT,hFont, 0
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC3),WM_SETFONT,hFont, 0 
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC4),WM_SETFONT,hFont, 0 
		fn SendMessage,FUNC (GetDlgItem,hWnd,IDC_STC5),WM_SETFONT,hFont, 0 
		
		invoke VolumeInfo
		
		mov hDP1,FUNC (GetDlgItem,hWin,IDC_DPG1)
		mov ebx, FUNC (atodw, addr numbuff2) ;count value
		invoke	atodw, addr numbuff1 ;maxi value
		sub eax, ebx
		mov ebx, eax
		fn SendMessage,hDP1,DP_INIT,ebx,FUNC (atodw, addr numbuff1)	
		invoke SendMessage,hDP1,DP_HBITMAP,pBmp1,0
		return 0

	Case WM_CTLCOLORDLG 
		mov eax,PBrushD
		ret	
					
	Case WM_CTLCOLORSTATIC
		invoke GetWindowLong,lParam,GWL_ID	
		.if eax == 1006 ; if free value item...
			Invoke 	SetBkMode, wParam, TRANSPARENT
			Invoke 	SetTextColor, wParam, 0080FFFFh ; ...change color.
			mov eax,PBrushD2
			ret	
		.else	
			Invoke 	SetBkMode, wParam, TRANSPARENT
			Invoke 	SetTextColor, wParam, 00FFC1C1h
			mov eax,PBrushD2
			ret
		.endif		

	Case WM_COMMAND		
		Switch wParam
		Case IDC_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		Endsw

	Case WM_CLOSE
		invoke DeleteObject,pBmp1
		invoke DeleteObject,pBmp2
		invoke DeleteObject,pBmp3
		invoke DeleteObject,pBmp4
		invoke DeleteObject,PBrushD
		invoke DeleteObject,PBrushD2
		invoke DeleteObject,PBrushD3
		invoke DeleteObject,hFont
		invoke EndDialog,hWin,0
	Endsw
		return 0	
DlgProc endp

VolumeInfo PROC
	LOCAL Volume[5]:BYTE
	LOCAL info[256]:BYTE
	LOCAL lpVolumeNameBuffer[MAX_PATH]:BYTE
	LOCAL PartLow:DWORD
	LOCAL PartHigh:DWORD
	LOCAL lpVolumeSerialNumber:DWORD
	LOCAL lpMaximumComponentLength:DWORD
	LOCAL lpFileSystemFlags:DWORD    
	LOCAL lpFileSystemNameBuffer:DWORD  
	LOCAL nFileSystemNameSize:DWORD
	LOCAL AvailableToCaller:QWORD 
	LOCAL TotalBytesUsed:QWORD
	
  	invoke GetSystemDirectory,addr info, sizeof info
  	invoke lstrcpyn, addr Volume, addr info, 4
	
  	invoke GetVolumeInformation, addr Volume, addr lpVolumeNameBuffer, sizeof lpVolumeNameBuffer,addr lpVolumeSerialNumber ,addr lpMaximumComponentLength, addr lpFileSystemFlags , addr lpFileSystemNameBuffer, 25  
	invoke GetDiskFreeSpaceEx, addr Volume, addr AvailableToCaller, addr TotalBytesUsed, NULL
	mov eax, DWORD PTR TotalBytesUsed 
	mov edx, DWORD PTR TotalBytesUsed + 4
	div Big10
	mov PartLow, edx 
	mov PartHigh, eax

	mov eax,PartLow ; division pour Mo...
	xor edx, edx 
	mov ecx, 1000000 
	div ecx 
	mov PartLow, eax
	fn wsprintf, addr numbuff1,"%d%.3d",PartHigh,PartLow
 
	mov eax, DWORD PTR AvailableToCaller 
	mov edx, DWORD PTR AvailableToCaller + 4
	div Big10
	mov PartLow, edx 
	mov PartHigh, eax

	mov eax,PartLow
	xor edx, edx 
	mov ecx, 1000000 ; division pour Mo...
	div ecx 
	mov PartLow, eax
	fn wsprintf, addr numbuff2,"%d%.3d",PartHigh,PartLow
	
	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 2, addr info," Volume : ", addr Volume
  	invoke SendDlgItemMessage,hWnd,IDC_STC2,WM_SETTEXT,0,addr info
  	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 2, addr info," Name : ",addr lpVolumeNameBuffer
  	invoke SendDlgItemMessage,hWnd,IDC_STC3,WM_SETTEXT,0,addr info
  	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 3, addr info," Total : ", addr numbuff1," Mo "
  	invoke SendDlgItemMessage,hWnd,IDC_STC4,WM_SETTEXT,0,addr info
  	invoke RtlZeroMemory,addr info, sizeof info
  	fn szMultiCat, 3, addr info," Free : ", addr numbuff2," Mo "
  	invoke SendDlgItemMessage,hWnd,IDC_STC5,WM_SETTEXT,0,addr info	       
  	ret
VolumeInfo ENDP 

end start